/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.dictionary;

import amberstone.resources.ResourceIterator;
import amberstone.data.ByteArray;

import java.io.IOException;

public class SegmentsIterator implements ResourceIterator
{
	private Dictionary[] segments;
	private int segmentIndex;
	private ResourceIterator iterator;

	public SegmentsIterator(Dictionary[] segments)
		throws IOException
	{
		this.segments = segments;
		this.iterator = segments[0].terms();
	}

	public ByteArray next() throws IOException
	{
		ByteArray bytes = null;
		if((bytes = iterator.next()) != null)
		{
			return bytes;
		}
		else
		{
			if(segmentIndex < segments.length)
			{
				this.iterator = segments[++segmentIndex].terms();
				return next();
			}
			else
			{
				return null;
			}
		}
	}
}