/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/


package amberstone.file;

import java.io.File;
import java.io.FileFilter;

public class RegexFilter implements FileFilter
{
	private String matches;

	public RegexFilter(String matches)
	{
		this.matches = matches;
	}

	public boolean accept(File file)
	{
		String name = file.getName();
		if(name.matches(matches))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}