/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import amberstone.report.*;
import amberstone.data.Key;
import amberstone.data.IntKey;

public class Add extends Function implements IntFunction, KeyFunction
{
	IntKey ikey = new IntKey();
	private IntFunction intFunc1;
	private IntFunction intFunc2;

	private static final FunctionType[][] allowed = {{FunctionType.INT_FUNCTION, FunctionType.INT_FUNCTION}};
	public FunctionType[][] strict()
	{
		return allowed;
	}

	public void params(Function[] params) throws ParameterException
	{
		this.intFunc1 = (IntFunction)params[0];
		this.intFunc2 = (IntFunction)params[1];
	}

	public int getInt() throws FunctionException
	{
		if(this.intFunc1 == null)
			throw new FunctionException("INT_FUNCTIONS are not set", this);

		return this.intFunc1.getInt()+this.intFunc2.getInt();
	}

	public Key getKey() throws FunctionException
	{
		ikey.setInt(this.intFunc1.getInt()+this.intFunc2.getInt());
		return ikey;
	}
}