/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import amberstone.data.ByteArray;

public class Contains extends Function implements BooleanFunction
{
	private BytesFunction sourceBytesFunc;
	private BytesFunction containsBytesFunc;

	private FunctionType[][] allowed = {{FunctionType.BYTES_FUNCTION, FunctionType.BYTES_FUNCTION}};

	public FunctionType[][] strict()
	{
		return allowed;
	}

	public void params(Function[] params) throws ParameterException
	{
		this.sourceBytesFunc    = (BytesFunction)params[0];
		this.containsBytesFunc  = (BytesFunction)params[1];
	}

	public boolean getBoolean() throws FunctionException
	{
		ByteArray sourceBytes = this.sourceBytesFunc.getBytes();
		ByteArray containsBytes = this.containsBytesFunc.getBytes();


		return sourceBytes.indexOf(containsBytes) > -1;
	}
}