/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/
package amberstone.lang;

import amberstone.data.Key;
import amberstone.data.CompoundKey;
import amberstone.data.DataRecord;

import java.util.Set;

public class Dimensions extends Function implements Dimension
{
	private Key key;
	private String dimensions;

	public FunctionType[][] strict()
	{
		return null;
	}

	public String getDimension()
	{
		return this.dimensions;
	}

	public void params(Function[] params) throws ParameterException
	{
		KeyFunction[] keys = new KeyFunction[params.length];
		for(int i=0; i<params.length; i++)
		{
			if(params[i] instanceof KeyFunction)
			{
				try
				{
					keys[i] = (KeyFunction)params[i];
					if(i>0)
					{
						this.dimensions = this.dimensions+"::"+((Dimension)params[i]).getDimension();
					}
					else
					{
						this.dimensions = ((Dimension)params[i]).getDimension();
					}
				}
				catch(Exception e)
				{
					throw new ParameterException(params[i], "Bad Dimension", e);
				}
			}
			else
			{
				throw new ParameterException(params[i], "Parameters for function 'dimensions' must be a DEMENSION");
			}
			CompoundKey ckey = new CompoundKey(keys);
			ckey.DELIM = "::";
			this.key = ckey;
		}
	}

	public Key getKey() throws FunctionException
	{
		return key;
	}
}