/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

public enum FunctionType
{
	NULLABLE("amberstone.lang.Nullable"),
	INT_FUNCTION("amberstone.lang.IntFunction"),
	DATE_FUNCTION("amberstone.lang.DateFunction"),
	TIME_FUNCTION("amberstone.lang.TimeFunction"),
	LONG_FUNCTION("amberstone.lang.LongFunction"),
	VOID_FUNCTION("amberstone.lang.VoidFunction"),
	SELECTOR("amberstone.read.Selector"),
	BYTES_FUNCTION("amberstone.lang.BytesFunction"),
	REPORT_FUNCTION("amberstone.lang.ReportFunction"),
	CHART_FUNCTION("amberstone.lang.ChartFunction"),
	DIRS_FUNCTION("amberstone.lang.DirsFunction"),
	DICTIONARY_FUNCTION("amberstone.lang.DictionaryFunction"),
	RESOURCE_FUNCTION("amberstone.lang.ResourceFunction"),
	BOOLEAN_FUNCTION("amberstone.lang.BooleanFunction"),
	VALVE_FUNCTION("amberstone.lang.ValveFunction"),
	KEY_FUNCTION("amberstone.lang.KeyFunction"),
	DIMENSION("amberstone.lang.Dimension"),
	TRANSACTION_FUNCTION("amberstone.lang.TransactionFunction"),
	STRING_LITERAL("amberstone.lang.StringLiteral"),
	NUMBER_LITERAL("amberstone.lang.NumberLiteral"),
	BOOLEAN_LITERAL("amberstone.lang.BooleanLiteral"),
	COMPARATOR("java.util.Comparator"),
	TIME_SERIES("amberstone.time.TimeSeries"),
	INCREMENT("amberstone.time.Increment"),
	DAY("amberstone.time.Day"),
	WEEK("amberstone.time.Week"),
	MONTH("amberstone.time.Month"),
	QUARTER("amberstone.time.Quarter"),
	YEAR("amberstone.time.Year"),
	LINK("amberstone.report.Link"),
	CONDITION("amberstone.report.Condition"),
	ROWS_FUNCTION("amberstone.report.RowsFunction"),
	ROW_FUNCTION("amberstone.report.RowFunction"),
	COLUMNS_FUNCTION("amberstone.report.ColumnsFunction"),
	COLUMN_FUNCTION("amberstone.report.ColumnFunction"),
	CELLS_FUNCTION("amberstone.report.CellsFunction"),
	SORT_DIRECTION("amberstone.report.SortDirection"),
	COMPARE_KEY("amberstone.report.CompareKey"),
	FORMATTER("amberstone.report.Formatter"),
	CELL_FUNCTION("amberstone.report.CellFunction"),
	ACTIVE_COLUMN("amberstone.report.ActiveColumn"),
	ACTIVE_ROW("amberstone.report.ActiveRow"),
	ACTIVE_KEY("amberstone.report.ActiveKey");

	private final String className;

	FunctionType(String className)
	{
		this.className = className;
	}

	public String getClassName()
	{
		return this.className;
	}
}