/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

public class GreaterThen extends Function implements BooleanFunction
{
	private LongFunction data;
	private LongFunction compare;

	private static final FunctionType[][] allow = {{FunctionType.LONG_FUNCTION, FunctionType.LONG_FUNCTION}};

	public FunctionType[][] strict()
	{
		return allow;
	}

	public void params(Function[] params) throws ParameterException
	{
		this.data =    (LongFunction)params[0];
		this.compare = (LongFunction)params[1];
	}

	public boolean getBoolean() throws FunctionException
	{
		return (data.getLong() > compare.getLong());
	}

}