/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import amberstone.data.*;
import amberstone.util.KeyValuePair;
import amberstone.report.*;
import java.util.Map;
import java.util.HashMap;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class InflateTime
{
	private IntFunction intFunc;
	private String template;
	private static Map<String, String> months = new HashMap();
	private Calendar cal = new GregorianCalendar();
	static
	{
		months.put("01", "Jan");
		months.put("02", "Feb");
		months.put("03", "Mar");
		months.put("04", "Apr");
		months.put("05", "May");
		months.put("06", "Jun");
		months.put("07", "Jul");
		months.put("08", "Aug");
		months.put("09", "Sep");
		months.put("10", "Oct");
		months.put("11", "Nov");
		months.put("12", "Dec");
	}



	public InflateTime(String template) throws ParameterException
	{
		this.template = template;
	}

	public ByteArray getBytes(int time) throws FunctionException
	{
		long ltime = ((long)time) * 1000l;
		cal.clear();
		cal.setTimeInMillis(ltime);
		String YYYY = Integer.toString(cal.get(cal.YEAR));
		String MM = pad(Integer.toString(cal.get(cal.MONTH)+1));
		String DD = pad(Integer.toString(cal.get(cal.DAY_OF_MONTH)));
		String hh = pad(Integer.toString(cal.get(cal.HOUR_OF_DAY)));
		String mm = pad(Integer.toString(cal.get(cal.MINUTE)));
		String ss = pad(Integer.toString(cal.get(cal.SECOND)));

		String temp = template.replace("YYYY", YYYY);
		if(temp.indexOf("Mon") > -1)
		{
			temp = temp.replace("Mon", months.get(MM));
		}
		else
		{
			temp = temp.replace("MM", MM);
		}
		temp = temp.replace("DD", DD);
		temp = temp.replace("hh", hh);
		temp = temp.replace("mm", mm);
		temp = temp.replace("ss", ss);

		return new ByteArray(temp);
	}

	private String pad(String s)
	{
		if(s.length() == 1)
		{
			return "0"+s;
		}

		return s;
	}
}