/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

import amberstone.data.StringKey;
import amberstone.data.Key;
import amberstone.data.ByteArray;
import amberstone.util.KeyValuePair;

public class StringLiteral extends Function implements Dimension,
                                                       BytesFunction
{
	private static Map<String, StringKey> literals = new HashMap();
	private StringKey literal;

	public FunctionType[][] strict()
	{
		return null;
	}

	public StringLiteral(String s)
	{
		super();
		if(literals.containsKey(s))
		{
			literal = literals.get(s);
		}
		else
		{
			literal = new StringKey(s);
			literals.put(s, literal);
		}

		this.funcs = new Function[0];
	}

	public String getCallName()
	{
		return "StringLiteral";
	}

	public Key getKey()
	{
		return literal;
	}

	public String getDimension()
	{
		return "";
	}

	public ByteArray getBytes() throws FunctionException
	{
		return literal.getBytes();
	}

	public String toString()
	{
		return literal.toString();
	}
}