/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import amberstone.summary.*;
import amberstone.read.*;
import amberstone.data.*;
import amberstone.time.*;


import java.util.List;
import java.math.BigDecimal;

public class Sum extends SummaryFunction
{
	private LongFunction longFunc;
	private LongFunction longFunc2;
	private LongFunction longFunc3;

	private Selector selector;
	private Record record;

	private static final FunctionType[][] allow = {{FunctionType.LONG_FUNCTION},
												   {FunctionType.LONG_FUNCTION, FunctionType.LONG_FUNCTION},
	                                               {FunctionType.LONG_FUNCTION, FunctionType.LONG_FUNCTION, FunctionType.LONG_FUNCTION}};

	public FunctionType[][] strict()
	{
		return allow;
	}

	public void params(Function[] params) throws ParameterException
	{
		this.longFunc = (LongFunction)params[0];
		this.values = params.length;
		if(params.length > 1)
		{
			this.longFunc2 = (LongFunction)params[1];
		}
		else
		{
			this.longFunc2 = new NumberLiteral(0);
		}

		if(params.length > 2)
		{
			this.longFunc3 = (LongFunction)params[2];
		}
		else
		{
			this.longFunc3 = new NumberLiteral(0);
		}
	}

 	public void operate(Point point) throws FunctionException
 	{
 		point.count+=longFunc.getLong();
 		point.count2+=longFunc2.getLong();
 		point.count3+=longFunc3.getLong();
 	}
}