/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.lang;

import amberstone.data.ByteArray;
import amberstone.util.MutableInteger;

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Map;
import java.util.HashMap;

public class UnixTime extends Function implements IntFunction, TimeFunction
{
	private int time;
	private Calendar cal = new GregorianCalendar();

	private static final FunctionType[][] allow = {{FunctionType.STRING_LITERAL}};

	public FunctionType[][] strict()
	{
		return allow;
	}

	public void params(Function[] params) throws ParameterException
	{
		String s = params[0].toString();
		int YYYY = Integer.parseInt(s.substring(6, 10));
		int MM =   Integer.parseInt(s.substring(0, 2));
		int DD = Integer.parseInt(s.substring(3, 5));
		int hh = Integer.parseInt(s.substring(11, 13));
		int mm = Integer.parseInt(s.substring(14, 16));
		int ss = Integer.parseInt(s.substring(17, 19));
		cal.set(YYYY, MM-1, DD, hh, mm, ss);
		this.time = (int)(cal.getTimeInMillis()/1000);
	}

	public int getTime() throws FunctionException
	{
		return time;
	}

	public int getInt() throws FunctionException
	{
		return time;
	}
}