/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.merge;

import java.math.BigDecimal;

public abstract class Merge
{
	public static final String ADD_MERGE_TYPE = "Add";
	public static final String MAX_MERGE_TYPE = "Max";
	private static Merge addMerge = new AddMerge();
	private static Merge maxMerge = new MaxMerge();

	public static Merge getInstance(String mergeType)
	{
		if(mergeType.equals(MAX_MERGE_TYPE))
		{
			return maxMerge;
		}
		else
		{
			return addMerge;
		}
	}

	public abstract BigDecimal merge(BigDecimal value1, BigDecimal value2);


}