/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.read;

import amberstone.lang.*;
import amberstone.data.*;

public class ReadKey implements Read
{
	private Object o;
	private String name;
	private String value;
	private Key key;

	public ReadKey(String name, Object o)
	{
		this.name = name;
		this.o = o;
	}

	public void read() throws FunctionException
	{
		value = o.toString();
	}

	public String getName()
	{
		return this.name;
	}

	public String getValue()
	{
		return o.toString();
	}

	public long getLong()
	{
		return Long.parseLong(getValue());
	}
}