/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.read;

import amberstone.data.*;
import amberstone.lang.*;
import java.io.*;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

public class Where extends Function implements Selector
{
	private Selector selector;
	private BooleanFunction filter;

	private static final FunctionType[][] allow = {{FunctionType.SELECTOR, FunctionType.BOOLEAN_FUNCTION}};

	public FunctionType[][] strict()
	{
		return allow;
	}

	public void params(Function[] params)
	{
		this.selector = (Selector) params[0];
		this.filter = (BooleanFunction) params[1];
	}

	public void open(int blockSize,
	                 String dir,
	                 DataRecord dataRecord, int startYYYYMMDD, int endYYYYMMDD) throws FunctionException
	{
		this.selector.open(blockSize, dir, dataRecord, startYYYYMMDD, endYYYYMMDD);
	}

	public Record next() throws FunctionException
	{
		while(true)
		{
			Record rec = selector.next();
			if(rec == null)
			{
				return null;
			}

			if(filter.getBoolean())
			{
				return rec;
			}
		}
	}
}