/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.report;

import amberstone.lang.*;
import amberstone.data.ByteArray;
import amberstone.util.KeyValuePair;

public class ActiveKey extends Function implements BytesFunction, IntFunction
{
	public static String ACTIVE_KEY;
	private int index = -1;

	private static final FunctionType[][] allow = {{}, {FunctionType.NUMBER_LITERAL}};

	public FunctionType[][] strict()
	{
		return allow;
	}

	public void params(Function[] params)
	{
		if(params.length == 1)
		{
			this.index = ((NumberLiteral)params[0]).getInt();
		}
	}

	public ByteArray getBytes()
	{
		if(index == -1)
		{
			return new ByteArray(ACTIVE_KEY);
		}
		else
		{
			String[] parts = ACTIVE_KEY.split("::");
			return new ByteArray(parts[index]);
		}
	}

	public int getInt()
	{
		if(index == -1)
		{
			return Integer.parseInt(ACTIVE_KEY);
		}
		else
		{
			String[] parts = ACTIVE_KEY.split("::");
			return Integer.parseInt(parts[index]);
		}
	}
}