/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.report;

import amberstone.lang.*;
import amberstone.data.ByteArray;

public class IndexFormatter extends Function implements BytesFunction
{
	private String delim;
	private int index;
	private BytesFunction[] bytesFuncs;

	public FunctionType[][] strict()
	{
		return null;
	}

	public void params(Function[] params)
	{
		this.delim = "::";
		bytesFuncs = new BytesFunction[params.length];
		for(int i=0; i<params.length; i++)
		{
			this.bytesFuncs[i] = (BytesFunction)params[i];
		}
	}

	public ByteArray getBytes() throws FunctionException
	{
		String key = ActiveKey.ACTIVE_KEY;
		String[] parts = key.split(delim);

		for(int i=0; i<parts.length; i++)
		{
			ActiveKey.ACTIVE_KEY = parts[i];
			ByteArray bytes = bytesFuncs[i].getBytes();
			parts[i] = bytes.toString();
		}

		String j = join(parts);
		return new ByteArray(j);
	}

	private String join(String[] values)
	{
		StringBuilder buf = new StringBuilder();
		for(int i=0; i<values.length; i++)
		{
			if(i>0)
			{
				buf.append(delim);
			}
			buf.append(values[i]);
		}

		return buf.toString();
	}
}