/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.summary;

import java.util.TreeSet;
import java.util.Iterator;
import amberstone.lang.*;
import amberstone.file.FileStat;
import amberstone.util.Primes;

public class CubeTemplate
	implements FileTemplate
{
	private String selectorClass;
	private String name;
	private KeyFunction keyFunc;
	private SummaryFunction operator;
	private int maxSize;
	private int view;
	private BooleanFunction filter;
	private BytesFunction bytesFunc;

	public CubeTemplate(String name,
					    int maxSize)
	{
		this.name = name;
		this.maxSize = maxSize;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public String getName()
	{
		return this.name;
	}

	public void setFilter(BooleanFunction filter)
	{
		this.filter = filter;
	}

	public void setBytesFunction(BytesFunction bytesFunc)
	{
		this.bytesFunc = bytesFunc;
	}

	public BytesFunction getBytesFunction()
	{
		return this.bytesFunc;
	}

	public void setKeyFunction(KeyFunction keyFunc)
	{
		this.keyFunc = keyFunc;
	}

	public SummaryFunction getOperator()
	{
		return this.operator;
	}

	public void setOperator(SummaryFunction operator)
	{
		this.operator = operator;
	}

	public void setSelectorClass(String selectorClass)
	{
		this.selectorClass = selectorClass;
	}

	public String getSelectorClass()
	{
		return this.selectorClass;
	}

	public FileNode getFileNode()
	{
		return new Cube(name,
					    maxSize,
					    operator,
					    keyFunc,
					    bytesFunc,
					    filter);
	}
}