/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/


package amberstone.summary;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.List;
import java.util.ArrayList;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;

import amberstone.read.*;
import amberstone.system.Logger;
import amberstone.file.FileHandler;
import amberstone.file.FileStat;
import amberstone.data.*;

import java.util.Comparator;
import java.util.Arrays;

public class WriterThread
	extends Thread
{
	private static BlockingQueue ready = new ArrayBlockingQueue(30000);

	public static void put(Object o)
	{
		ready.add(o);
	}

	public void run()
	{
		try
		{
			while(true)
			{
				Object o = ready.take();
				if(!(o instanceof FileNode))
				{
					return;
				}
				else
				{
					((FileNode)o).output();
				}
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}