/*
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
*/

package amberstone.system;

import amberstone.merge.Merger;

public class MergeCommand implements Command
{
	private boolean valid;

	public MergeCommand(String args[])
	{
		if(args.length == 1)
		{
			valid = true;
		}
		else
		{
			valid = false;
		}
	}

	public boolean valid()
	{
		return valid;
	}

	public String usage()
	{
		return "-merge";
	}

	public Selector getSelector()
	{
		return null;
	}

	public void run(Config config)
	{
		try
		{
			Merger m = new Merger(config);
			m.merge();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public boolean needsResources()
	{
		return false;
	}
}