/**
*
*	Copyright 2012 Joel Bernstein
*
*	Licensed under the Apache License, Version 2.0 (the "License");
*	you may not use this file except in compliance with the License.
*	You may obtain a copy of the License at
*
*	 http://www.apache.org/licenses/LICENSE-2.0
*
*	Unless required by applicable law or agreed to in writing, software
*	distributed under the License is distributed on an "AS IS" BASIS,
*	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*	See the License for the specific language governing permissions and
*	limitations under the License.
*
**/

package amberstone.transaction;

import amberstone.data.*;
import java.util.*;

class KeySort implements Comparator
{
	public int compare(Object o1, Object o2)
	{
		Key key1 = (Key)o1;
		Key key2 = (Key)o2;

		int hash1 = key1.hashCode();
		int hash2 = key2.hashCode();

		if(hash1 > hash2)
		{
			return 1;
		}
		else if(hash1 < hash2)
		{
			return -1;
		}
		else
		{
			if(key1 instanceof BytesKey)
			{
				String s1 = key1.toString();
				String s2 = key2.toString();
				return s1.compareTo(s2);
			}
			else
			{
				return 0;
			}
		}
	}
}